;********************************************************************************
;* TEST passembly                       versio 1        Lleonard Garcia i Llop*
;********************************************************************************
; 1.-Per estalviar energia es pot col_locar un led bicolor en lloc del motor.
; 2.-FONT D'ALIMENTACI? PSU ATX.
;    Les fonts d'alimentaci? atx disposen d'un conector de 20 o 24 terminals
;    que es connecten a la tarja base d'un PC. Si ens fixem en un connector de 
;    24 terminals sempre per el terminal 9 (color lila) apareix 5v_SBY, que es
;    una tensi? standby de 5v-10mA que alimenta un microcontrolador. Per ficar 
;    en marxa la font cal conduir el terminal 16 (color verd) PS_ON a negatiu.
;    Aix? ho far? el microcontrolador a traves d'un transistor. Un cop la font
;    s'ha connectat informa a traves del terminal 8 ( color gris) PWR_OK que 
;    totes les sortides estan operatives i correctes.
;    El color vermell 55, el color groc 12v i el color taronja 3,3v.    
; 3.-CIRCUIT IMPRES QUE UTILITZA PICAXE 14M2
;                        **********************
;                    +V  * 1               14 *  GND
;  programacio/debug C.5 * 2               13 *  B.0      programacio / debug
;  PS_ON             C.4 * 3               12 *  B.1      potenciometre A (dalt)
;  polsador          C.3 * 4               11 *  B.2      potenciometre B (baix)
;  interruptor       C.2 * 5               10 *  B.3      I2C_SCL
;  jumper            C.1 * 6                9 *  B.4      I2C_SDA
;  IR_TSOP4838       C.0 * 7                8 *  B.5      PWR_good
;                        **********************

;CONFIGURACIONS DEL HARDWARE
symbol sensor=C.0
symbol jumper=pinC.1
symbol interruptor=pinC.2
symbol polsador=pinC.3
symbol sortida=C.4
symbol pot_A=B.1
symbol pot_B=B.2
symbol SCL=B.3
symbol SDA=B.4
symbol powergood=pinB.5
pause 2000
;DEFINICIONS DE VARIABLES
symbol codi_IR_=b0
symbol codi_IR_ready=b1
symbol estat=b2		; 1.-encessa  0.- apagada
let estat=0
symbol estat_pre=b3
let estat_pre=1
symbol mode=b4
let mode=0
symbol compte_on=b5
let compte_on=0
symbol compte_off=b6
let compte_off=0
symbol limit_on=b7
symbol limit_off=b8
inicialitzacio:
let dirsC=%00010000           		; Config port_C(1=sortida 0=entrada).
low sortida
setint %00000000,%00000001 ; Permetre interrupcions per C.0 a nivell baix.
main:
TestJumper:
if jumper=1 then let mode=1
	else let mode=0
		endif

Test_IR:
if codi_IR_=0 then TestPolsador
if codi_IR_=16 then let estat_pre=1
				goto TestPolsador
				endif
if codi_IR_=17 then let estat_pre=0 endif
let codi_IR_=0

TestPolsador:
if estat=0 and polsador=1 then let estat_pre=1 endif
if estat=1 and polsador=1 then let estat_pre=0 endif
;goto Fi_test_pot_off
TestPotenciometre:
if mode=0 then Fi_test_pot_off
readadc pot_A,limit_on ; Llegeix potenciometre A desa en b0
readadc pot_B,limit_off ; Llegeix potenciometre A desa en b2
if limit_on<10 then let limit_on=10 endif
if limit_off<10 then let limit_off=10 endif
if estat=0 then Fi_test_pot_on
if compte_on=<limit_on then
	let compte_on=compte_on+1
	pause 100
			    else
	let compte_on=0
	let estat_pre=0
endif
Fi_test_pot_on:
if estat=1 then Fi_test_pot_off
if compte_off=<limit_off then
	let compte_off=compte_off+1
	pause 100
			    else
	let compte_off=0
	let estat_pre=1
endif
Fi_test_pot_off:

TestInterruptor:
if interruptor=1 then refresc
if interruptor=0 then let estat_pre=0 endif	

refresc:
if estat_pre=1 and estat=0 then 
						high sortida 
						let estat=1 
						pause 300 
						endif
if estat_pre=0 and estat=1 then
	low sortida 
	let estat=0 
	pause 300 
	endif
goto main

;SUBRUTINES
interrupt:
irin [1000,timeout_irin],sensor,codi_IR_ ; llegir TSOP4838 i desar en codi_IR.
let codi_IR_ready=1
timeout_irin:
setint %00000000,%00000001 ; Reactivar interrupcions per C.0 a nivell baix.
return
				; SI